/*********************************************************************************
*	 FileName:  device.cpp						                                             *
*  Module:  	Device Class Module fo PASS Library DLL.                           *
*  Version:		0.0                                                                *
*  Date:			12/14/93                                                           *
*  Author:		L. Allen                                                           *
*                                                                                *
*  Update History                                                                *
*                                                                                *
*  update    ver   description (author)                                          *
*  -------   ---   -----------                                                   *
*  9312.14   0.0   Work begun. (LA)                                              *
*                                                                                *
*	 Description:                                                                  *
*                                                                                *
*  This is the main file for the device class for the ABI-PC2 board.             *
*                                                                                *
**********************************************************************************/
#include <windows.h>
#include <owl.h>
#include <stdio.h>
#include <string.h>
extern "C"
{
 #include "sbsdpmi2.h"
}
#include "device.h"


 TDevice::TDevice(PTWindowsObject AParent, WORD IO, WORD MEMBASE,
                             WORD INTLEVEL)
 {

   // startup test values
/*   WORD y,x1,x2,x3,x4;
   long int i;
   BOOL err;
   
 // Save parameters
   baseadr = MEMBASE;
   io = IO;
   interupt = INTLEVEL;
   parentwin = AParent;

   DeviceOk = TRUE;

   linearadr = (long int)baseadr << 16;

   if(!GetSelector(linearadr, MemSize, &selector))
    {
     MessageBox(0, "Error assigning selector for ABI-PC2 board.",
                "PASS DLL Error",MB_OK);
     SelectorOk = FALSE;
     DeviceOk = FALSE;
     return;
    }
   else
    {
     SelectorOk = TRUE;
     // Do board start-up test

     err = FALSE;
     // Inable IO on board
     outport(io, 1);
     y = gr(0);
     x1 = y & 0x2ff;
     pr(0,x1);
     pr(1,0xaaaa);
     pr(2,0x5555);

     for(i=0;i<200000L;i++);

     x2 = gr(1);
     if(x2==0xaaaa)
      err = TRUE;
     else
      {
       x3 = gr(0) | 0x100;
       pr(0,x3);
       x3 = gr(0);
       pr(1,0xaaaa);
       pr(2,0x5555);
       x4 = gr(1);
       if(x4 != 0xaaaa)
        err = TRUE;
      }
     pr(0,y);

     if(err)
      {
       MessageBox(0, "ABI-PC2 Device not responding.",
                  "PASS DLL Error", MB_OK);
       DeviceOk = FALSE;
      }
     else
      {
       // Set Voltage
       pr(0x1f,0x80);
      }
   } */
 }

TDevice::~TDevice()
 {
   // Free board selector
/*   if(SelectorOk)
    FreeDesc(selector);

   // disable board
   outport(io,0); */
 }
    
  
WORD TDevice::gr(WORD adr)
 {
/*  if(DeviceOk)
   return GR(selector,adr);
  else            */
   return 0xFFFF; 
 }
void TDevice::pr(WORD adr, WORD val)
 {
//   if(DeviceOk)
//     PR(selector,adr,val);
 }
BOOL TDevice::start_uc(void)
 {
   BOOL started = FALSE;
   int i,count=0;
   WORD y,z;

  if(DeviceOk)
  {
   while((count < 2) && (!started))
    {
      pr(0,1);                      // reset board
      pr(0x10, MapAdr);             // Load map register
      pr(0x3f,0);
      pr(0x40,0);
      if(count==0)
       {
        pr(0,0x140);
        pr(0,0x142);
       }
      else
       {
        pr(0,0x340);
        pr(0,0x342);
       }
      y = gr(0x40);
      i=0;
      while((i++<20000)&&(y==0))
       y=gr(0x40);

      z=gr(0x40);
      if(( z==0x904)||( z==0x903))
       started = TRUE;
      else
       ++count;
    }
   }
   DeviceOk = started;
   return started;
 }

void TDevice::stop_uc(void)
 {
  if(DeviceOk)
    pr(0,1);
 }
void TDevice::start_monitor(void)
 {
 }
void TDevice::stop_monitor(FILE *OPENFILE)
 {
 }
