/*********************************************************************************
*	 FileName:  PASSLIB.h   									                                     *
*  Module:  	Header for Main Module for PASS Library DLL.                       *
*  Version:		0.0                                                                *
*  Date:			12/13/93                                                           *
*  Author:		L. Allen                                                           *
*                                                                                *
*  Update History                                                                *
*                                                                                *
*  update    ver   description (author)                                          *
*  -------   ---   -----------                                                   *
*  9312.13   0.0   Work begun. (LA)                                              *
*                                                                                *
*	 Description:                                                                  *
*                                                                                *
*  This module contains the LibMain function and interrupt handler for the Pass  *
*  DLL.                                                                          *
*                                                                                *
**********************************************************************************/
extern "C"
{
 void far  InitMonitor(HWND ParentHWnd, WORD IO, WORD MEMBASE,
                             WORD INTLEVEL);

 void far CloseMonitor(void);

 void far MonitorAll(void);

 void far SetMonitorClock(int day, int hour, int min, int sec);

 WORD far MGR(WORD adr);

 void far MPR(WORD adr,WORD val);

 BOOL far StartUC(void);

 void far StopUC(void);

 void far InitializeLog(FILE *SAVEFILE,long int FILESIZE);

}


